# To run this example you need:
#	- RPi
#	- KAmodRPiADCDAC module
#	- Wire to connect VIN and VOU pins on KAmod Con2 connector

import time
import sys
import curses
import KAmodRPiADCDAC

screen = curses.initscr()
curses.noecho()
curses.cbreak()
screen.keypad(True)

try:
	KAmod = KAmodRPiADCDAC.KAmodRPiADCDAC()

	# Set VINmax to the same value as JP2 jumper on KAmod board
	KAmod.setVINmax(5)

	daValue = 0
	while True:

		# Write daValue to DAC
		KAmod.writeMCP4716(daValue)

		# Read voltage from ADC
		voltage = KAmod.readMCP3021Voltage()

		screen.addstr('\rADC Voltage = %.2fV, DAC Value = %d     ' % (voltage, daValue))

		char = screen.getch()
		if char == curses.KEY_UP:
			daValue += 5
		elif char == curses.KEY_DOWN:
			daValue -= 5

		if daValue > 1023:
			daValue = 1023
		elif daValue < 0:
				daValue = 0
finally:
	curses.nocbreak(); screen.keypad(0); curses.echo()
	curses.endwin()
